SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL';

DROP SCHEMA IF EXISTS `##DATABASENAME##` ;
CREATE SCHEMA IF NOT EXISTS `##DATABASENAME##` DEFAULT CHARACTER SET utf8 ;
USE `##DATABASENAME##` ;

-- -----------------------------------------------------
-- Table `##DATABASENAME##`.`hrdlog`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `##DATABASENAME##`.`hrdlog` ;

CREATE  TABLE IF NOT EXISTS `##DATABASENAME##`.`hrdlog` (
  `QsoId` BIGINT(20) NOT NULL ,
  `HrdLogId` DECIMAL(10,0) NOT NULL ,
  `OriginalCall` VARCHAR(50) NOT NULL ,
  `OriginalQsoDate` VARCHAR(8) NOT NULL ,
  `OriginalTimeOn` VARCHAR(6) NOT NULL ,
  PRIMARY KEY (`QsoId`) )
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

CREATE UNIQUE INDEX `QsoId` ON `##DATABASENAME##`.`hrdlog` (`QsoId` ASC) ;

CREATE UNIQUE INDEX `HrdLogId` ON `##DATABASENAME##`.`hrdlog` (`HrdLogId` ASC) ;

-- -----------------------------------------------------
-- Table `##DATABASENAME##`.`informations`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `##DATABASENAME##`.`informations` ;

CREATE  TABLE IF NOT EXISTS `##DATABASENAME##`.`informations` (
  `DBVersion` VARCHAR(10) NULL DEFAULT NULL )
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

INSERT INTO `##DATABASENAME##`.`informations` SET `DBVersion`  = '6';

-- -----------------------------------------------------
-- Table `##DATABASENAME##`.`log`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `##DATABASENAME##`.`log` ;

CREATE  TABLE IF NOT EXISTS `##DATABASENAME##`.`log` (
  `QsoId` BIGINT(20) NOT NULL ,
  `Call` VARCHAR(50) NOT NULL ,
  `Band` VARCHAR(50) NOT NULL ,
  `Mode` VARCHAR(10) NOT NULL ,
  `QsoDate` VARCHAR(50) NOT NULL DEFAULT '' ,
  `TimeOn` VARCHAR(20) NOT NULL DEFAULT '' ,
  `Address` VARCHAR(300) NOT NULL DEFAULT '' ,
  `MyAntenna` VARCHAR(100) NOT NULL DEFAULT '' ,
  `Age` VARCHAR(10) NOT NULL DEFAULT '' ,
  `AIndex` INT(11) NOT NULL DEFAULT 0 ,
  `AntPath` VARCHAR(50) NOT NULL DEFAULT '' ,
  `AntAz` INT(11) NOT NULL DEFAULT 0 ,
  `AntEl` INT(11) NOT NULL DEFAULT 0 ,
  `TenTen` INT(11) NOT NULL DEFAULT 0 ,
  `ArrlSect` VARCHAR(50) NOT NULL DEFAULT '' ,
  `ArrlCheck` VARCHAR(50) NOT NULL DEFAULT '' ,
  `TheClass` VARCHAR(50) NOT NULL DEFAULT '' ,
  `CreditSubmitted` VARCHAR(200) NOT NULL DEFAULT '' ,
  `CreditGranted` VARCHAR(200) NOT NULL DEFAULT '' ,
  `BandRx` VARCHAR(50) NOT NULL DEFAULT '' ,
  `Cont` VARCHAR(10) NOT NULL DEFAULT '' ,
  `ContactedOp` VARCHAR(50) NOT NULL DEFAULT '' ,
  `ContestId` VARCHAR(50) NOT NULL DEFAULT '' ,
  `Country` VARCHAR(50) NOT NULL DEFAULT '' ,
  `Cqz` INT(11) NOT NULL DEFAULT 0 ,
  `Distance` INT(11) NOT NULL DEFAULT 0 ,
  `Dxcc` VARCHAR(50) NOT NULL DEFAULT '' ,
  `EqCall` VARCHAR(50) NOT NULL DEFAULT '' ,
  `Email` VARCHAR(100) NOT NULL DEFAULT '' ,
  `EqslQslRDate` VARCHAR(20) NOT NULL DEFAULT '' ,
  `EqslQslSDate` VARCHAR(20) NOT NULL DEFAULT '' ,
  `EqslQslRcvd` VARCHAR(20) NOT NULL DEFAULT '' ,
  `EqslQslSent` VARCHAR(20) NOT NULL DEFAULT '' ,
  `ForceInit` INT(11) NOT NULL DEFAULT 0 ,
  `Freq` VARCHAR(50) NOT NULL DEFAULT '' ,
  `FreqRx` VARCHAR(50) NOT NULL DEFAULT '' ,
  `GridSquare` VARCHAR(10) NOT NULL DEFAULT '' ,
  `Iota` VARCHAR(50) NOT NULL DEFAULT '' ,
  `IotaIslandId` VARCHAR(200) NOT NULL DEFAULT '' ,
  `Ituz` INT(11) NOT NULL DEFAULT 0 ,
  `KIndex` INT(11) NOT NULL DEFAULT 0 ,
  `Lat` VARCHAR(20) NOT NULL DEFAULT '' ,
  `Lon` VARCHAR(20) NOT NULL DEFAULT '' ,
  `MaxBursts` INT(11) NOT NULL DEFAULT 0 ,
  `MsShower` VARCHAR(50) NOT NULL DEFAULT '' ,
  `MyLat` VARCHAR(20) NOT NULL DEFAULT '' ,
  `MyLon` VARCHAR(20) NOT NULL DEFAULT '' ,
  `LotwQslRDate` VARCHAR(50) NOT NULL DEFAULT '' ,
  `LotwQslSDate` VARCHAR(50) NOT NULL DEFAULT '' ,
  `LotwQslRcvd` VARCHAR(50) NOT NULL DEFAULT '' ,
  `LotwQslSent` VARCHAR(50) NOT NULL DEFAULT '' ,
  `MyCity` VARCHAR(50) NOT NULL DEFAULT '' ,
  `MyCnty` VARCHAR(100) NOT NULL DEFAULT '' ,
  `MyCountry` VARCHAR(50) NOT NULL DEFAULT '' ,
  `MyCqZone` INT(11) NOT NULL DEFAULT 0 ,
  `MyGridSquare` VARCHAR(10) NOT NULL DEFAULT '' ,
  `Myiota` VARCHAR(50) NOT NULL DEFAULT '' ,
  `MyIotaIslandId` VARCHAR(200) NOT NULL DEFAULT '' ,
  `MyItuZone` INT(11) NOT NULL DEFAULT 0 ,
  `MyName` VARCHAR(300) NOT NULL DEFAULT '' ,
  `MyPostalCode` VARCHAR(50) NOT NULL DEFAULT '' ,
  `MyRig` VARCHAR(300) NOT NULL DEFAULT '' ,
  `MySig` VARCHAR(300) NOT NULL DEFAULT '' ,
  `MySigInfo` VARCHAR(300) NOT NULL DEFAULT '' ,
  `MyState` VARCHAR(50) NOT NULL DEFAULT '' ,
  `MyStreet` VARCHAR(100) NOT NULL DEFAULT '' ,
  `Name` VARCHAR(100) NOT NULL DEFAULT '' ,
  `Notes` VARCHAR(2000) NOT NULL DEFAULT '' ,
  `NrBursts` INT(11) NOT NULL DEFAULT 0 ,
  `NrPings` INT(11) NOT NULL DEFAULT 0 ,
  `Pfx` VARCHAR(50) NOT NULL DEFAULT '' ,
  `TheOperator` VARCHAR(50) NOT NULL DEFAULT '' ,
  `OwnerCallsign` VARCHAR(50) NOT NULL DEFAULT '' ,
  `Precedence` VARCHAR(50) NOT NULL DEFAULT '' ,
  `PropMode` VARCHAR(50) NOT NULL DEFAULT '' ,
  `PublicKey` VARCHAR(256) NOT NULL DEFAULT '' ,
  `ProgramId` VARCHAR(50) NOT NULL DEFAULT '' ,
  `ProgramVersion` VARCHAR(50) NOT NULL DEFAULT '' ,
  `QslMsg` VARCHAR(300) NOT NULL DEFAULT '' ,
  `QslRDate` VARCHAR(50) NOT NULL DEFAULT '' ,
  `QslSDate` VARCHAR(50) NOT NULL DEFAULT '' ,
  `QslRcvd` VARCHAR(50) NOT NULL DEFAULT '' ,
  `QslRcvdVia` VARCHAR(50) NOT NULL DEFAULT '' ,
  `QslSent` VARCHAR(50) NOT NULL DEFAULT '' ,
  `QslSentVia` VARCHAR(50) NOT NULL DEFAULT '' ,
  `QslVia` VARCHAR(300) NOT NULL DEFAULT '' ,
  `QsoComplete` VARCHAR(10) NOT NULL DEFAULT '' ,
  `QsoDateOff` VARCHAR(50) NOT NULL DEFAULT '' ,
  `QsoRandom` VARCHAR(50) NOT NULL DEFAULT '' ,
  `Qth` VARCHAR(300) NOT NULL DEFAULT '' ,
  `Rig` VARCHAR(300) NOT NULL DEFAULT '' ,
  `Sfi` INT(11) NOT NULL DEFAULT 0 ,
  `RstRcvd` VARCHAR(10) NOT NULL DEFAULT '' ,
  `RstSent` VARCHAR(10) NOT NULL DEFAULT '' ,
  `SatMode` VARCHAR(20) NOT NULL DEFAULT '' ,
  `SatName` VARCHAR(20) NOT NULL DEFAULT '' ,
  `Sig` VARCHAR(300) NOT NULL DEFAULT '' ,
  `SigInfo` VARCHAR(300) NOT NULL DEFAULT '' ,
  `Srx` VARCHAR(10) NOT NULL DEFAULT '' ,
  `SrxString` VARCHAR(50) NOT NULL DEFAULT '' ,
  `State` VARCHAR(50) NOT NULL DEFAULT '' ,
  `StationCallsign` VARCHAR(50) NOT NULL DEFAULT '' ,
  `Stx` VARCHAR(10) NOT NULL DEFAULT '' ,
  `StxString` VARCHAR(50) NOT NULL DEFAULT '' ,
  `Swl` VARCHAR(10) NOT NULL DEFAULT '' ,
  `TimeOff` VARCHAR(20) NOT NULL DEFAULT '' ,
  `ValidatedCallsign` BIT(1) NOT NULL DEFAULT 0 ,
  `ManualDateTime` BIT(1) NOT NULL DEFAULT 0 ,
  `Mobile` BIT(1) NOT NULL DEFAULT 0 ,
  `Qrp` BIT(1) NOT NULL DEFAULT 0 ,
  `Portable` BIT(1) NOT NULL DEFAULT 0 ,
  `CallsignUrl` VARCHAR(100) NOT NULL DEFAULT '' ,
  `HomepageUrl` VARCHAR(100) NOT NULL DEFAULT '' ,
  `Contest` BIT(1) NOT NULL DEFAULT 0 ,
  `Cnty` VARCHAR(50) NOT NULL DEFAULT '' ,
  `Comment` VARCHAR(300) NOT NULL DEFAULT '' ,
  `submissionstatus` VARCHAR(50) NOT NULL DEFAULT '' ,

  `ClublogQsoUploadDate` VARCHAR(20) NOT NULL DEFAULT '',
  `ClublogQsoUploadStatus` VARCHAR(20) NOT NULL DEFAULT '',
  `AwardSubmitted` VARCHAR(500) NOT NULL DEFAULT '',
  `AwardGranted` VARCHAR(500) NOT NULL DEFAULT '',
  `Fists` VARCHAR(50) NOT NULL DEFAULT '',
  `FistsCc` VARCHAR(50) NOT NULL DEFAULT '',
  `HrdlogQsoUploadDate` VARCHAR(20) NOT NULL DEFAULT '',
  `HrdlogQsoUploadStatus` VARCHAR(20) NOT NULL DEFAULT '',
  `MyFists` VARCHAR(50) NOT NULL DEFAULT '',
  `MySotaRef` VARCHAR(50) NOT NULL DEFAULT '',
  `MyUsacaCounties` VARCHAR(50) NOT NULL DEFAULT '',
  `MyVuccGrids` VARCHAR(50) NOT NULL DEFAULT '',
  `QrzcomQsoUploadDate` VARCHAR(20) NOT NULL DEFAULT '',
  `QrzcomQsoUploadStatus` VARCHAR(20) NOT NULL DEFAULT '',
  `RxPwrDecimal` decimal(10,3) NOT NULL DEFAULT 0,
  `TxPwrDecimal` decimal(10,3) NOT NULL DEFAULT 0,
  `Skcc` VARCHAR(50) NOT NULL DEFAULT '',
  `SotaRef` VARCHAR(50) NOT NULL DEFAULT '',
  `SubMode` VARCHAR(50) NOT NULL DEFAULT '',
  `UsacaCounties` VARCHAR(500) NOT NULL DEFAULT '',
  `VuccGrids` VARCHAR(500) NOT NULL DEFAULT '',
  `QsoAwards` VARCHAR(5000) NOT NULL DEFAULT '',

  PRIMARY KEY (`Mode`,`QsoDate`,`TimeOn`,`Band`,`Call`),
  UNIQUE KEY `QsoId_UNIQUE` (`QsoId`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='ANSI'; 
USE ##DATABASENAME## ; 
DROP PROCEDURE IF EXISTS ##DATABASENAME##.drop_user_if_exists ; 
DELIMITER $$ 
CREATE PROCEDURE ##DATABASENAME##.drop_user_if_exists() 
BEGIN 
  DECLARE foo BIGINT DEFAULT 0 ; 
  SELECT COUNT(*) 
  INTO foo 
    FROM mysql.user 
      WHERE User = '##DATABASENAME##User' and  Host = 'localhost'; 
   IF foo > 0 THEN 
         REVOKE ALL PRIVILEGES ON *.* FROM '##DATABASENAME##User'@'localhost';
         DROP USER '##DATABASENAME##User'@'localhost' ; 
  END IF; 
  
    SELECT COUNT(*) 
  INTO foo 
    FROM mysql.user 
      WHERE User = '##DATABASENAME##User'; 
   IF foo > 0 THEN 
         REVOKE ALL PRIVILEGES ON *.* FROM '##DATABASENAME##User';
         DROP USER '##DATABASENAME##User' ; 
  END IF; 
  
END ;$$ 
DELIMITER ; 
CALL ##DATABASENAME##.drop_user_if_exists() ; 
DROP PROCEDURE IF EXISTS ##DATABASENAME##.drop_users_if_exists ; 
SET SQL_MODE=@OLD_SQL_MODE ;

CREATE USER '##DATABASENAME##User'@'localhost' IDENTIFIED BY '##DATABASENAME##User';

grant INSERT on TABLE `##DATABASENAME##`.`hrdlog` to '##DATABASENAME##User'@'localhost';
grant SELECT on TABLE `##DATABASENAME##`.`hrdlog` to '##DATABASENAME##User'@'localhost';
grant UPDATE on TABLE `##DATABASENAME##`.`hrdlog` to '##DATABASENAME##User'@'localhost';
grant INDEX on TABLE `##DATABASENAME##`.`hrdlog` to '##DATABASENAME##User'@'localhost';
grant DELETE on TABLE `##DATABASENAME##`.`hrdlog` to '##DATABASENAME##User'@'localhost';

grant INDEX on TABLE `##DATABASENAME##`.`informations` to '##DATABASENAME##User'@'localhost';
grant INSERT on TABLE `##DATABASENAME##`.`informations` to '##DATABASENAME##User'@'localhost';
grant SELECT on TABLE `##DATABASENAME##`.`informations` to '##DATABASENAME##User'@'localhost';
grant UPDATE on TABLE `##DATABASENAME##`.`informations` to '##DATABASENAME##User'@'localhost';
grant DELETE on TABLE `##DATABASENAME##`.`informations` to '##DATABASENAME##User'@'localhost';

grant INDEX on TABLE `##DATABASENAME##`.`log` to '##DATABASENAME##User'@'localhost';
grant INSERT on TABLE `##DATABASENAME##`.`log` to '##DATABASENAME##User'@'localhost';
grant SELECT on TABLE `##DATABASENAME##`.`log` to '##DATABASENAME##User'@'localhost';
grant UPDATE on TABLE `##DATABASENAME##`.`log` to '##DATABASENAME##User'@'localhost';
grant DELETE on TABLE `##DATABASENAME##`.`log` to '##DATABASENAME##User'@'localhost';

CREATE USER '##DATABASENAME##User' IDENTIFIED BY '##DATABASENAME##User';

grant INSERT on TABLE `##DATABASENAME##`.`hrdlog` to '##DATABASENAME##User' ;
grant SELECT on TABLE `##DATABASENAME##`.`hrdlog` to '##DATABASENAME##User' ;
grant UPDATE on TABLE `##DATABASENAME##`.`hrdlog` to '##DATABASENAME##User' ;
grant INDEX on TABLE `##DATABASENAME##`.`hrdlog` to '##DATABASENAME##User' ;
grant DELETE on TABLE `##DATABASENAME##`.`hrdlog` to '##DATABASENAME##User' ;

grant INDEX on TABLE `##DATABASENAME##`.`informations` to '##DATABASENAME##User' ;
grant INSERT on TABLE `##DATABASENAME##`.`informations` to '##DATABASENAME##User' ;
grant SELECT on TABLE `##DATABASENAME##`.`informations` to '##DATABASENAME##User' ;
grant UPDATE on TABLE `##DATABASENAME##`.`informations` to '##DATABASENAME##User' ;
grant DELETE on TABLE `##DATABASENAME##`.`informations` to '##DATABASENAME##User' ;

grant INDEX on TABLE `##DATABASENAME##`.`log` to '##DATABASENAME##User' ;
grant INSERT on TABLE `##DATABASENAME##`.`log` to '##DATABASENAME##User' ;
grant SELECT on TABLE `##DATABASENAME##`.`log` to '##DATABASENAME##User' ;
grant UPDATE on TABLE `##DATABASENAME##`.`log` to '##DATABASENAME##User' ;
grant DELETE on TABLE `##DATABASENAME##`.`log` to '##DATABASENAME##User' ;

SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
